\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{
  frame=single,
  showstringspaces=false,
  columns=fixed,
  basicstyle={\ttfamily},
  commentstyle={\it},
  numbers=left,
  tabsize=4
}
\begin{document}
\lstset{
  language={[ANSI]C},
  morekeywords={FileLsOptions, __attribute__, va_list, size_t, PATH_MAX, NULL, DIR},
  title=Contents of \texttt{src/finder.h}
}
\begin{lstlisting}
#ifndef _FINDER_H
#define _FINDER_H
typedef enum
{
    ALL      = 0x0000, // All files.
    EXCL_OLD = 0x0100, // Exclude files with changes older than OLD_TIME.
    EXCL_OWN = 0x0200, // Exclude files, not owned by current user.
    EXCL_DOT = 0x0400, // Exclude hidden files. (starting with a dot)
    EXCL_REG = 0x1000, // Exclude regular files from result.
    EXCL_SYM = 0x2000, // Exclude symlinks from result.
    EXCL_DIR = 0x4000, // Exclude directories from result. (doesn't recurse)
    EXCL_OTH = 0x8000, // Exclude block and character dev, FIFO, pipes, sockets.
    _IND_MSK = 0x00ff, // Bitmask for indentation bytes. (implementation only)
    _IND_ONE = 0x0001, // One level of indentation.      (implementation only)
} FileLsOptions;

// Defines section for settings, changeable at compile time.
#ifndef IND_CHAR // Character to use for indentation (def is space)
#define IND_CHAR ' '
#endif

#ifndef MAX_INDL // Max indentation level (def is 70 spaces for 80 char tty)
#define MAX_INDL 70
#endif

#ifndef OLD_TIME // Time in seconds, selects 'old' files (def is 2 weeks)
#define OLD_TIME 1209600
#endif

// Function declarations.
void finder(const char *dirname, FileLsOptions opt);
void filels(const char *dirname, const char *filename, FileLsOptions opt);
#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{src/terminator.h}}
\begin{lstlisting}
#ifndef _TERMINATOR_H
#define _TERMINATOR_H

void terminate(int code, const char *fmt, ...)
    __attribute__ ((noreturn))
    __attribute__ ((format (printf, 2, 3)));

#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{src/cfind.c}}
\begin{lstlisting}
#include "finder.h"
#include "terminator.h"

int main(int argc, char *argv[])
{
    if (argc != 2)
        terminate(0, "Usage: %s PATH\n", argv[0]);

    finder(argv[1], EXCL_SYM | EXCL_OLD | EXCL_OWN);
}
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/finder.c}}
\begin{lstlisting}
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <limits.h>
#include <stdio.h>
#include <sys/stat.h>
#include <time.h>
#include <string.h>

#include "finder.h"
#include "terminator.h"

void filels(const char *dirname, const char *filename, FileLsOptions opt)
{
    // Ignore . and ..
    if (!strncmp(".", filename, 3) || !strncmp("..", filename, 3))
        return;

    // Get the lenght of {dirname}/{filename}.
    size_t pathlen = 1 + snprintf(NULL, 0, "%s/%s", dirname, filename);
    pathlen = (pathlen > PATH_MAX) ? PATH_MAX : pathlen;

    // Obtain a string with full filename.
    char filepath[pathlen];
    snprintf(filepath, pathlen, "%s/%s", dirname, filename);

    // Get stat of flie.
    struct stat filestat;
    if (lstat(filepath, &filestat))
        terminate(errno, "Can't stat file '%s'.\n", filepath);

    // If file is too old, skip. (enabled with EXCL_OLD)
    if ((opt & EXCL_OLD) && filestat.st_mtime < (time(NULL) - OLD_TIME))
        return;

    // If user doesn't own the file, skip. (enabled with EXCL_OWN)
    if ((opt & EXCL_OWN) && filestat.st_uid != geteuid())
        return;

    // If file is hidden, skip. (enabled with EXCL_DOT)
    if ((opt & EXCL_DOT) && filename[0] == '.')
        return;

    // If regular file, skip. (enabled with EXCL_REG)
    if ((opt & EXCL_REG) && S_ISREG(filestat.st_mode))
        return;

    // If symlink, skip. (enabled with EXCL_SYM)
    if ((opt & EXCL_SYM) && S_ISLNK(filestat.st_mode))
        return;

    // If directory, skip. (enabled with EXCL_DIR)
    if ((opt & EXCL_DIR) && S_ISDIR(filestat.st_mode))
        return;

    // If its an `other` kind of file, skip. (enabled with EXCL_OTH)
    if ((opt & EXCL_OTH)
            && !S_ISREG(filestat.st_mode)
            && !S_ISLNK(filestat.st_mode)
            && !S_ISDIR(filestat.st_mode))
        return;

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
    // Print indentation.
    unsigned indent = opt&_IND_MSK;
    indent = (indent > MAX_INDL) ? MAX_INDL : indent;
    while (indent--)
        putchar(IND_CHAR);

    // Print filename.
    printf("%s\n", filename);

    // If directory, print all the subdirectories, but indented one more step.
    if (S_ISDIR(filestat.st_mode)) {
        // If we haven't filled the indentation bytes, increase indentation.
        if ((opt & _IND_MSK) != _IND_MSK)
            opt += _IND_ONE;
        finder(filepath, opt);
    }
}

void finder(const char *dirname, FileLsOptions opt)
{
    // Open directory.
    DIR *dir = opendir(dirname);
    if (!dir || !dirname)
        terminate(errno, "Can't open directory '%s'.\n", dirname);

    // For every file in the directory, list that file.
    struct dirent *file;
    while ((file = readdir(dir)))
        filels(dirname, file->d_name, opt);

    // Close directory.
    closedir(dir);
}
\end{lstlisting}
\lstset{title=Contents of \texttt{src/terminator.c}}
\begin{lstlisting}
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "terminator.h"

void terminate(int code, const char *fmt, ...)
{
    // Print the formatted message.
    va_list args;
    va_start(args, fmt);
    vprintf(fmt, args);
    va_end(args);

    // Print the error message, if any.
    if (code)
        printf("Error: %s \n", strerror(code));

    exit(code);
}
\end{lstlisting}
\newpage
\lstset{
  language={[gnu]make},
  title=Contents of \texttt{makefile}
}
\begin{lstlisting}
CFLAGS= -Wall -g -O3

vpath %.c src

cfind: cfind.o finder.o terminator.o
finder.o: terminator.o

.PHONY:clean
clean:
	rm -f *.o cfind
\end{lstlisting}
\lstset{
  language=,
  morekeywords={NAME, SYNOPSIS, DESCRIPTION, NOTES, EXAMPLES, AUTHOR, COPYRIGHT},
  moredelim=[is][\it]{<|}{|>},
  moredelim=[is][\bf]{<:}{:>},
  title=Contents of \texttt{README.cfind}
}
\begin{lstlisting}
NAME
        <:cfind:> - recursively iterate throught directories and pr|>int files,
            matching requirements.

SYNOPSIS
        <:cfind:> <|PATH|>

DESCRIPTION
        <:cfind:> is a wrapper for the finder library, which uses the settings of:
            <|EXCL_SYM|>, <|EXCL_OLD|> and <|EXCL_OWN|>
        for more information please refer to finder library documentation.

EXAMPLES
        <:cfind:> testdir
        <:cfind:> .
        <:cfind:> /home/user/projects

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{README.finder}}
\begin{lstlisting}
NAME
        <:finder:> - the recursive file iterator library, has many options for
            specifying, which files to exclude from iteration and how to
            output them.

SYNOPSIS
        <:finder:>(const char *<:dirname:>, FileLsOptions <:opt:>)

DESCRIPTION
        <:dirname:>
        should be a null-terminated string, that specifies a valid path to
        a directory. Examples of valid paths are:
            "."     "testdir"     "/tmp/dir1"

        <:opt:>
        should be <|ALL|> or a bitwise '|' of the following options:
            <|EXCL_OLD|> - Exclude files with changes older than <|OLD_TIME|>.
            <|EXCL_OWN|> - Exclude files, not owned by current user.
            <|EXCL_DOT|> - Exclude hidden files from result.
            <|EXCL_REG|> - Exclude regular files from result.
            <|EXCL_SYM|> - Exclude symlinks from result.
            <|EXCL_DIR|> - Exclude directories from result.
                            This option also disables recursion.
            <|EXCL_OTH|> - Exclude block and character dev, FIFO, pipes and sockets.

        Additionaly, the following options can be changed, when compiling the
        library (by exporting a macro definition with changed values):
            <|IND_CHAR|> - The character for indentation of subdirectories contents.
                            Default: ' ' (space)
            <|MAX_INDL|> - The maximum indentation level (in characters).
                            Default: 70 (Maximum: 255)
            <|OLD_TIME|> - The time in seconds, which specifies, how old should the
                            file be for it to be considered to old to list,
                            according to <|EXCL_OLD|> option.
                            Default: 1209600 (2 weeks)

NOTES
        Although the option <|MAX_INDL|> is included, keep in mind, that this macro
        only defines the maximum number of indentation symbols, preceding the
        filename. The filename is always printed in full, so wrapping lines
        for long filenames in inevitable.

EXAMPLES
        // Print all files in directory testdir.
        <:finder:>("testdir", <|ALL|>);
        
        // Print all directories, existing on the system.
        <:finder:>("/", <|EXCL_SYM|> | <|EXCL_OTH|> | <|EXCL_REG|>);

        // Print all non-hidden files in the current directory,
        // which the running user owns.
        <:finder:>(".", <|EXCL_OWN|> | <|EXCL_DOT|>);

        // Print all files in the current directory newer than 2 weeks.
        // (Doesn't recurse into subdirectories)
        <:finder:>(".", <|EXCL_DIR|> | <|EXCL_OLD|>);

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\newpage
\lstset{
  language={[ANSI]C},
  title=Contents of \texttt{cheater/cheater.c}
}
\begin{lstlisting}
#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
    // I am sorry, I had to do it.
    char euid[64];
    snprintf(euid, sizeof(euid), "%u", geteuid());
    execlp("find", "find", argv[1],
            "!", "-type", "l",
            "-mtime", "-14",
            "-uid", euid, NULL);
}
\end{lstlisting}
\end{document}
